/* math-window.c generated by valac 0.32.0.13-d82f, the Vala compiler
 * generated from math-window.vala, do not modify */

/*
 * Copyright (C) 1987-2008 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (C) 2008-2012 Robert Ancell.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "libcalculator.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gtksourceview/gtksource.h>


#define TYPE_MATH_WINDOW (math_window_get_type ())
#define MATH_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_WINDOW, MathWindow))
#define MATH_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_WINDOW, MathWindowClass))
#define IS_MATH_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_WINDOW))
#define IS_MATH_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_WINDOW))
#define MATH_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_WINDOW, MathWindowClass))

typedef struct _MathWindow MathWindow;
typedef struct _MathWindowClass MathWindowClass;
typedef struct _MathWindowPrivate MathWindowPrivate;

#define TYPE_MATH_DISPLAY (math_display_get_type ())
#define MATH_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_DISPLAY, MathDisplay))
#define MATH_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_DISPLAY, MathDisplayClass))
#define IS_MATH_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_DISPLAY))
#define IS_MATH_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_DISPLAY))
#define MATH_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_DISPLAY, MathDisplayClass))

typedef struct _MathDisplay MathDisplay;
typedef struct _MathDisplayClass MathDisplayClass;

#define TYPE_MATH_BUTTONS (math_buttons_get_type ())
#define MATH_BUTTONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_BUTTONS, MathButtons))
#define MATH_BUTTONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_BUTTONS, MathButtonsClass))
#define IS_MATH_BUTTONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_BUTTONS))
#define IS_MATH_BUTTONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_BUTTONS))
#define MATH_BUTTONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_BUTTONS, MathButtonsClass))

typedef struct _MathButtons MathButtons;
typedef struct _MathButtonsClass MathButtonsClass;

#define TYPE_MATH_CONVERTER (math_converter_get_type ())
#define MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_CONVERTER, MathConverter))
#define MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_CONVERTER, MathConverterClass))
#define IS_MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_CONVERTER))
#define IS_MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_CONVERTER))
#define MATH_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_CONVERTER, MathConverterClass))

typedef struct _MathConverter MathConverter;
typedef struct _MathConverterClass MathConverterClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_BUTTON_MODE (button_mode_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MathWindow {
	GtkApplicationWindow parent_instance;
	MathWindowPrivate * priv;
};

struct _MathWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _MathWindowPrivate {
	MathEquation* _equation;
	MathDisplay* _display;
	MathButtons* _buttons;
	gboolean right_aligned;
	gboolean remove_buttons;
	GtkMenuButton* menu_button;
	GtkLabel* mode_label;
	GtkScrolledWindow* scrolled_window;
	GtkGrid* grid;
	MathConverter* converter;
};

typedef enum  {
	BUTTON_MODE_BASIC,
	BUTTON_MODE_ADVANCED,
	BUTTON_MODE_FINANCIAL,
	BUTTON_MODE_PROGRAMMING,
	BUTTON_MODE_KEYBOARD
} ButtonMode;


static gpointer math_window_parent_class = NULL;

GType math_window_get_type (void) G_GNUC_CONST;
GType math_display_get_type (void) G_GNUC_CONST;
GType math_buttons_get_type (void) G_GNUC_CONST;
GType math_converter_get_type (void) G_GNUC_CONST;
#define MATH_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MATH_WINDOW, MathWindowPrivate))
enum  {
	MATH_WINDOW_DUMMY_PROPERTY,
	MATH_WINDOW_EQUATION,
	MATH_WINDOW_DISPLAY,
	MATH_WINDOW_BUTTONS
};
static void math_window_copy_cb (MathWindow* self);
static void _math_window_copy_cb_gsimple_action_activate_callback (GSimpleAction* action, GVariant* parameter, gpointer self);
static void math_window_paste_cb (MathWindow* self);
static void _math_window_paste_cb_gsimple_action_activate_callback (GSimpleAction* action, GVariant* parameter, gpointer self);
static void math_window_undo_cb (MathWindow* self);
static void _math_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action, GVariant* parameter, gpointer self);
static void math_window_redo_cb (MathWindow* self);
static void _math_window_redo_cb_gsimple_action_activate_callback (GSimpleAction* action, GVariant* parameter, gpointer self);
static void math_window_mode_cb (MathWindow* self, GSimpleAction* action, GVariant* parameter);
static void _math_window_mode_cb_gsimple_action_activate_callback (GSimpleAction* action, GVariant* parameter, gpointer self);
MathWindow* math_window_new (GtkApplication* app, MathEquation* equation);
MathWindow* math_window_construct (GType object_type, GtkApplication* app, MathEquation* equation);
void math_converter_set_equation (MathConverter* self, MathEquation* equation);
void math_converter_set_category (MathConverter* self, const gchar* category);
void math_converter_set_conversion (MathConverter* self, const gchar* unit_a, const gchar* unit_b);
MathDisplay* math_display_new (MathEquation* equation);
MathDisplay* math_display_construct (GType object_type, MathEquation* equation);
void math_display_grabfocus (MathDisplay* self);
MathButtons* math_buttons_new (MathEquation* equation);
MathButtons* math_buttons_construct (GType object_type, MathEquation* equation);
GType button_mode_get_type (void) G_GNUC_CONST;
ButtonMode math_buttons_get_mode (MathButtons* self);
static void math_window_mode_changed_cb (MathWindow* self);
static void _math_window_mode_changed_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
MathButtons* math_window_get_buttons (MathWindow* self);
void math_window_critical_error (MathWindow* self, const gchar* title, const gchar* contents);
static gboolean math_window_real_key_press_event (GtkWidget* base, GdkEventKey* event);
MathEquation* math_window_get_equation (MathWindow* self);
static void math_window_scroll_changed_cb (MathWindow* self, GtkAdjustment* adjustment);
static void _math_window_scroll_changed_cb_gtk_adjustment_changed (GtkAdjustment* _sender, gpointer self);
static void math_window_scroll_value_changed_cb (MathWindow* self, GtkAdjustment* adjustment);
static void _math_window_scroll_value_changed_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
MathDisplay* math_window_get_display (MathWindow* self);
void math_display_grab_focus (MathDisplay* self);
void math_buttons_set_mode (MathButtons* self, ButtonMode value);
static void math_window_finalize (GObject* obj);
static void _vala_math_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);

static const GActionEntry MATH_WINDOW_window_entries[5] = {{"copy", _math_window_copy_cb_gsimple_action_activate_callback, NULL, NULL, NULL}, {"paste", _math_window_paste_cb_gsimple_action_activate_callback, NULL, NULL, NULL}, {"undo", _math_window_undo_cb_gsimple_action_activate_callback, NULL, NULL, NULL}, {"redo", _math_window_redo_cb_gsimple_action_activate_callback, NULL, NULL, NULL}, {"mode", _math_window_mode_cb_gsimple_action_activate_callback, "s", "\"basic\"", NULL}};

static void _math_window_copy_cb_gsimple_action_activate_callback (GSimpleAction* action, GVariant* parameter, gpointer self) {
#line 36 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_window_copy_cb ((MathWindow*) self);
#line 165 "math-window.c"
}


static void _math_window_paste_cb_gsimple_action_activate_callback (GSimpleAction* action, GVariant* parameter, gpointer self) {
#line 36 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_window_paste_cb ((MathWindow*) self);
#line 172 "math-window.c"
}


static void _math_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action, GVariant* parameter, gpointer self) {
#line 36 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_window_undo_cb ((MathWindow*) self);
#line 179 "math-window.c"
}


static void _math_window_redo_cb_gsimple_action_activate_callback (GSimpleAction* action, GVariant* parameter, gpointer self) {
#line 36 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_window_redo_cb ((MathWindow*) self);
#line 186 "math-window.c"
}


static void _math_window_mode_cb_gsimple_action_activate_callback (GSimpleAction* action, GVariant* parameter, gpointer self) {
#line 36 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_window_mode_cb ((MathWindow*) self, action, parameter);
#line 193 "math-window.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 200 "math-window.c"
}


static void _math_window_mode_changed_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 67 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_window_mode_changed_cb ((MathWindow*) self);
#line 207 "math-window.c"
}


MathWindow* math_window_construct (GType object_type, GtkApplication* app, MathEquation* equation) {
	MathWindow * self = NULL;
	GtkApplication* _tmp0_ = NULL;
	MathEquation* _tmp1_ = NULL;
	MathEquation* _tmp2_ = NULL;
	MathConverter* _tmp3_ = NULL;
	MathEquation* _tmp4_ = NULL;
	MathConverter* _tmp5_ = NULL;
	MathConverter* _tmp6_ = NULL;
	MathEquation* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	MathEquation* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	MathEquation* _tmp15_ = NULL;
	MathDisplay* _tmp16_ = NULL;
	GtkScrolledWindow* _tmp17_ = NULL;
	MathDisplay* _tmp18_ = NULL;
	MathDisplay* _tmp19_ = NULL;
	MathDisplay* _tmp20_ = NULL;
	MathEquation* _tmp21_ = NULL;
	MathButtons* _tmp22_ = NULL;
	GtkGrid* _tmp23_ = NULL;
	MathButtons* _tmp24_ = NULL;
	gboolean _tmp25_ = FALSE;
	MathButtons* _tmp26_ = NULL;
	ButtonMode _tmp27_ = 0;
	ButtonMode _tmp28_ = 0;
	MathButtons* _tmp29_ = NULL;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp30_ = NULL;
	GdkScreen* _tmp31_ = NULL;
#line 45 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 45 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 47 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = app;
#line 47 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	self = (MathWindow*) g_object_new (object_type, "application", _tmp0_, NULL);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp1_ = equation;
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->_equation);
#line 48 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	self->priv->_equation = _tmp2_;
#line 49 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	self->priv->right_aligned = TRUE;
#line 51 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_action_map_add_action_entries ((GActionMap*) self, MATH_WINDOW_window_entries, G_N_ELEMENTS (MATH_WINDOW_window_entries), self);
#line 53 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp3_ = self->priv->converter;
#line 53 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp4_ = self->priv->_equation;
#line 53 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_converter_set_equation (_tmp3_, _tmp4_);
#line 54 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp5_ = self->priv->converter;
#line 54 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_converter_set_category (_tmp5_, NULL);
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp6_ = self->priv->converter;
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp7_ = equation;
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp8_ = math_equation_get_source_units (_tmp7_);
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp9_ = _tmp8_;
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp10_ = _tmp9_;
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp11_ = equation;
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp12_ = math_equation_get_target_units (_tmp11_);
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp13_ = _tmp12_;
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp14_ = _tmp13_;
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_converter_set_conversion (_tmp6_, _tmp10_, _tmp14_);
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_free0 (_tmp14_);
#line 55 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_free0 (_tmp10_);
#line 57 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp15_ = equation;
#line 57 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp16_ = math_display_new (_tmp15_);
#line 57 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_object_ref_sink (_tmp16_);
#line 57 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->_display);
#line 57 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	self->priv->_display = _tmp16_;
#line 58 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp17_ = self->priv->scrolled_window;
#line 58 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp18_ = self->priv->_display;
#line 58 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 59 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp19_ = self->priv->_display;
#line 59 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp19_);
#line 60 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp20_ = self->priv->_display;
#line 60 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_display_grabfocus (_tmp20_);
#line 62 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp21_ = equation;
#line 62 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp22_ = math_buttons_new (_tmp21_);
#line 62 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_object_ref_sink (_tmp22_);
#line 62 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->_buttons);
#line 62 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	self->priv->_buttons = _tmp22_;
#line 63 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp23_ = self->priv->grid;
#line 63 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp24_ = self->priv->_buttons;
#line 63 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 65 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp26_ = self->priv->_buttons;
#line 65 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp27_ = math_buttons_get_mode (_tmp26_);
#line 65 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp28_ = _tmp27_;
#line 65 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	if (_tmp28_ != BUTTON_MODE_KEYBOARD) {
#line 65 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp25_ = TRUE;
#line 350 "math-window.c"
	} else {
#line 65 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp25_ = FALSE;
#line 354 "math-window.c"
	}
#line 65 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	self->priv->remove_buttons = _tmp25_;
#line 67 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp29_ = self->priv->_buttons;
#line 67 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_signal_connect_object ((GObject*) _tmp29_, "notify::mode", (GCallback) _math_window_mode_changed_cb_g_object_notify, self, 0);
#line 68 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_window_mode_changed_cb (self);
#line 70 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp30_ = gtk_css_provider_new ();
#line 70 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	provider = _tmp30_;
#line 71 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_css_provider_load_from_resource (provider, "/org/gnome/calculator/calculator.css");
#line 72 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp31_ = gtk_window_get_screen ((GtkWindow*) self);
#line 72 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_style_context_add_provider_for_screen (_tmp31_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 45 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (provider);
#line 45 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	return self;
#line 378 "math-window.c"
}


MathWindow* math_window_new (GtkApplication* app, MathEquation* equation) {
#line 45 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	return math_window_construct (TYPE_MATH_WINDOW, app, equation);
#line 385 "math-window.c"
}


static void math_window_mode_changed_cb (MathWindow* self) {
	GSimpleAction* action = NULL;
	GAction* _tmp0_ = NULL;
	GSimpleAction* _tmp1_ = NULL;
	MathButtons* _tmp2_ = NULL;
	MathButtons* _tmp3_ = NULL;
	ButtonMode _tmp4_ = 0;
	ButtonMode _tmp5_ = 0;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
#line 75 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 77 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, "mode");
#line 77 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction));
#line 77 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	action = _tmp1_;
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp2_ = math_window_get_buttons (self);
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp3_ = _tmp2_;
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp4_ = math_buttons_get_mode (_tmp3_);
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp5_ = _tmp4_;
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	switch (_tmp5_) {
#line 417 "math-window.c"
		default:
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		case BUTTON_MODE_BASIC:
#line 421 "math-window.c"
		{
			GtkLabel* _tmp6_ = NULL;
			const gchar* _tmp7_ = NULL;
			GSimpleAction* _tmp8_ = NULL;
			GVariant* _tmp9_ = NULL;
			GVariant* _tmp10_ = NULL;
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp6_ = self->priv->mode_label;
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp7_ = _ ("Basic Mode");
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			gtk_label_set_label (_tmp6_, _tmp7_);
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp8_ = action;
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp9_ = g_variant_new_string ("basic");
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			g_variant_ref_sink (_tmp9_);
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp10_ = _tmp9_;
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			g_simple_action_set_state (_tmp8_, _tmp10_);
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_g_variant_unref0 (_tmp10_);
#line 85 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			break;
#line 448 "math-window.c"
		}
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		case BUTTON_MODE_ADVANCED:
#line 452 "math-window.c"
		{
			GtkLabel* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
			GSimpleAction* _tmp13_ = NULL;
			GVariant* _tmp14_ = NULL;
			GVariant* _tmp15_ = NULL;
#line 88 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp11_ = self->priv->mode_label;
#line 88 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp12_ = _ ("Advanced Mode");
#line 88 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			gtk_label_set_label (_tmp11_, _tmp12_);
#line 89 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp13_ = action;
#line 89 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp14_ = g_variant_new_string ("advanced");
#line 89 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			g_variant_ref_sink (_tmp14_);
#line 89 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp15_ = _tmp14_;
#line 89 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			g_simple_action_set_state (_tmp13_, _tmp15_);
#line 89 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_g_variant_unref0 (_tmp15_);
#line 90 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			break;
#line 479 "math-window.c"
		}
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		case BUTTON_MODE_FINANCIAL:
#line 483 "math-window.c"
		{
			GtkLabel* _tmp16_ = NULL;
			const gchar* _tmp17_ = NULL;
			GSimpleAction* _tmp18_ = NULL;
			GVariant* _tmp19_ = NULL;
			GVariant* _tmp20_ = NULL;
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp16_ = self->priv->mode_label;
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp17_ = _ ("Financial Mode");
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			gtk_label_set_label (_tmp16_, _tmp17_);
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp18_ = action;
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp19_ = g_variant_new_string ("financial");
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			g_variant_ref_sink (_tmp19_);
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp20_ = _tmp19_;
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			g_simple_action_set_state (_tmp18_, _tmp20_);
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_g_variant_unref0 (_tmp20_);
#line 95 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			break;
#line 510 "math-window.c"
		}
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		case BUTTON_MODE_PROGRAMMING:
#line 514 "math-window.c"
		{
			GtkLabel* _tmp21_ = NULL;
			const gchar* _tmp22_ = NULL;
			GSimpleAction* _tmp23_ = NULL;
			GVariant* _tmp24_ = NULL;
			GVariant* _tmp25_ = NULL;
#line 98 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp21_ = self->priv->mode_label;
#line 98 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp22_ = _ ("Programming Mode");
#line 98 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			gtk_label_set_label (_tmp21_, _tmp22_);
#line 99 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp23_ = action;
#line 99 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp24_ = g_variant_new_string ("programming");
#line 99 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			g_variant_ref_sink (_tmp24_);
#line 99 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp25_ = _tmp24_;
#line 99 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			g_simple_action_set_state (_tmp23_, _tmp25_);
#line 99 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_g_variant_unref0 (_tmp25_);
#line 100 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			break;
#line 541 "math-window.c"
		}
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		case BUTTON_MODE_KEYBOARD:
#line 545 "math-window.c"
		{
			GtkLabel* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
			GSimpleAction* _tmp28_ = NULL;
			GVariant* _tmp29_ = NULL;
			GVariant* _tmp30_ = NULL;
#line 103 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp26_ = self->priv->mode_label;
#line 103 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp27_ = _ ("Keyboard Mode");
#line 103 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			gtk_label_set_label (_tmp26_, _tmp27_);
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp28_ = action;
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp29_ = g_variant_new_string ("keyboard");
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			g_variant_ref_sink (_tmp29_);
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp30_ = _tmp29_;
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			g_simple_action_set_state (_tmp28_, _tmp30_);
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_g_variant_unref0 (_tmp30_);
#line 105 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			break;
#line 572 "math-window.c"
		}
	}
#line 108 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp32_ = self->priv->remove_buttons;
#line 108 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	if (_tmp32_ == TRUE) {
#line 579 "math-window.c"
		MathButtons* _tmp33_ = NULL;
		ButtonMode _tmp34_ = 0;
		ButtonMode _tmp35_ = 0;
#line 108 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp33_ = self->priv->_buttons;
#line 108 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp34_ = math_buttons_get_mode (_tmp33_);
#line 108 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp35_ = _tmp34_;
#line 108 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp31_ = _tmp35_ != BUTTON_MODE_KEYBOARD;
#line 591 "math-window.c"
	} else {
#line 108 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp31_ = FALSE;
#line 595 "math-window.c"
	}
#line 108 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	if (_tmp31_) {
#line 599 "math-window.c"
		MathButtons* _tmp36_ = NULL;
		MathConverter* _tmp37_ = NULL;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp36_ = self->priv->_buttons;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp36_);
#line 111 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		self->priv->remove_buttons = FALSE;
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp37_ = self->priv->converter;
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp37_);
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 614 "math-window.c"
	} else {
		gboolean _tmp38_ = FALSE;
		gboolean _tmp39_ = FALSE;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp39_ = self->priv->remove_buttons;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		if (_tmp39_ == FALSE) {
#line 622 "math-window.c"
			MathButtons* _tmp40_ = NULL;
			ButtonMode _tmp41_ = 0;
			ButtonMode _tmp42_ = 0;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp40_ = self->priv->_buttons;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp41_ = math_buttons_get_mode (_tmp40_);
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp42_ = _tmp41_;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp38_ = _tmp42_ == BUTTON_MODE_KEYBOARD;
#line 634 "math-window.c"
		} else {
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp38_ = FALSE;
#line 638 "math-window.c"
		}
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		if (_tmp38_) {
#line 642 "math-window.c"
			MathButtons* _tmp43_ = NULL;
			MathConverter* _tmp44_ = NULL;
#line 117 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp43_ = self->priv->_buttons;
#line 117 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			gtk_widget_hide ((GtkWidget*) _tmp43_);
#line 118 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			self->priv->remove_buttons = TRUE;
#line 119 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp44_ = self->priv->converter;
#line 119 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			gtk_widget_show ((GtkWidget*) _tmp44_);
#line 120 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			gtk_window_set_resizable ((GtkWindow*) self, TRUE);
#line 657 "math-window.c"
		}
	}
#line 75 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (action);
#line 662 "math-window.c"
}


void math_window_critical_error (MathWindow* self, const gchar* title, const gchar* contents) {
	GtkMessageDialog* dialog = NULL;
	const gchar* _tmp0_ = NULL;
	GtkMessageDialog* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
#line 124 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 124 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (title != NULL);
#line 124 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (contents != NULL);
#line 126 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = title;
#line 126 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp1_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, 0, GTK_MESSAGE_ERROR, GTK_BUTTONS_NONE, "%s", _tmp0_);
#line 126 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_object_ref_sink (_tmp1_);
#line 126 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	dialog = _tmp1_;
#line 130 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp2_ = contents;
#line 130 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_message_dialog_format_secondary_text (dialog, "%s", _tmp2_);
#line 131 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp3_ = _ ("_Quit");
#line 131 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_dialog_add_buttons ((GtkDialog*) dialog, _tmp3_, GTK_RESPONSE_ACCEPT, NULL);
#line 133 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_dialog_run ((GtkDialog*) dialog);
#line 135 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 124 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (dialog);
#line 700 "math-window.c"
}


static gboolean math_window_real_key_press_event (GtkWidget* base, GdkEventKey* event) {
	MathWindow * self;
	gboolean result = FALSE;
	gboolean _result_ = FALSE;
	GdkEventKey* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	MathButtons* _tmp3_ = NULL;
	MathButtons* _tmp4_ = NULL;
	ButtonMode _tmp5_ = 0;
	ButtonMode _tmp6_ = 0;
#line 138 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	self = (MathWindow*) base;
#line 138 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = event;
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp1_ = GTK_WIDGET_CLASS (math_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), _tmp0_);
#line 140 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_result_ = _tmp1_;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp3_ = math_window_get_buttons (self);
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp4_ = _tmp3_;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp5_ = math_buttons_get_mode (_tmp4_);
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp6_ = _tmp5_;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	if (_tmp6_ == BUTTON_MODE_PROGRAMMING) {
#line 735 "math-window.c"
		GdkEventKey* _tmp7_ = NULL;
		GdkModifierType _tmp8_ = 0;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp7_ = event;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp8_ = _tmp7_->state;
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp2_ = (_tmp8_ & GDK_CONTROL_MASK) == GDK_CONTROL_MASK;
#line 744 "math-window.c"
	} else {
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp2_ = FALSE;
#line 748 "math-window.c"
	}
#line 142 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	if (_tmp2_) {
#line 752 "math-window.c"
		GdkEventKey* _tmp9_ = NULL;
		guint _tmp10_ = 0U;
#line 144 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp9_ = event;
#line 144 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp10_ = _tmp9_->keyval;
#line 144 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		switch (_tmp10_) {
#line 144 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			case GDK_KEY_b:
#line 763 "math-window.c"
			{
				MathEquation* _tmp11_ = NULL;
				MathEquation* _tmp12_ = NULL;
#line 148 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				_tmp11_ = math_window_get_equation (self);
#line 148 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				_tmp12_ = _tmp11_;
#line 148 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				math_equation_set_number_base (_tmp12_, 2);
#line 149 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				result = TRUE;
#line 149 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				return result;
#line 777 "math-window.c"
			}
#line 144 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			case GDK_KEY_o:
#line 781 "math-window.c"
			{
				MathEquation* _tmp13_ = NULL;
				MathEquation* _tmp14_ = NULL;
#line 152 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				_tmp13_ = math_window_get_equation (self);
#line 152 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				_tmp14_ = _tmp13_;
#line 152 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				math_equation_set_number_base (_tmp14_, 8);
#line 153 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				result = TRUE;
#line 153 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				return result;
#line 795 "math-window.c"
			}
#line 144 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			case GDK_KEY_d:
#line 799 "math-window.c"
			{
				MathEquation* _tmp15_ = NULL;
				MathEquation* _tmp16_ = NULL;
#line 156 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				_tmp15_ = math_window_get_equation (self);
#line 156 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				_tmp16_ = _tmp15_;
#line 156 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				math_equation_set_number_base (_tmp16_, 10);
#line 157 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				result = TRUE;
#line 157 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				return result;
#line 813 "math-window.c"
			}
#line 144 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			case GDK_KEY_h:
#line 817 "math-window.c"
			{
				MathEquation* _tmp17_ = NULL;
				MathEquation* _tmp18_ = NULL;
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				_tmp17_ = math_window_get_equation (self);
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				_tmp18_ = _tmp17_;
#line 160 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				math_equation_set_number_base (_tmp18_, 16);
#line 161 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				result = TRUE;
#line 161 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				return result;
#line 831 "math-window.c"
			}
			default:
#line 144 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			break;
#line 836 "math-window.c"
		}
	}
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	result = _result_;
#line 165 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	return result;
#line 843 "math-window.c"
}


static void math_window_scroll_changed_cb (MathWindow* self, GtkAdjustment* adjustment) {
	gboolean _tmp0_ = FALSE;
#line 169 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 169 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (adjustment != NULL);
#line 171 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = self->priv->right_aligned;
#line 171 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	if (_tmp0_) {
#line 857 "math-window.c"
		GtkAdjustment* _tmp1_ = NULL;
		GtkAdjustment* _tmp2_ = NULL;
		gdouble _tmp3_ = 0.0;
		GtkAdjustment* _tmp4_ = NULL;
		gdouble _tmp5_ = 0.0;
#line 172 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp1_ = adjustment;
#line 172 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp2_ = adjustment;
#line 172 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp3_ = gtk_adjustment_get_upper (_tmp2_);
#line 172 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp4_ = adjustment;
#line 172 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp5_ = gtk_adjustment_get_page_size (_tmp4_);
#line 172 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		gtk_adjustment_set_value (_tmp1_, _tmp3_ - _tmp5_);
#line 875 "math-window.c"
	}
}


static void _math_window_scroll_changed_cb_gtk_adjustment_changed (GtkAdjustment* _sender, gpointer self) {
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_window_scroll_changed_cb ((MathWindow*) self, _sender);
#line 883 "math-window.c"
}


static void math_window_scroll_value_changed_cb (MathWindow* self, GtkAdjustment* adjustment) {
	GtkAdjustment* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	GtkAdjustment* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
	GtkAdjustment* _tmp4_ = NULL;
	gdouble _tmp5_ = 0.0;
#line 176 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 176 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (adjustment != NULL);
#line 178 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = adjustment;
#line 178 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
#line 178 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp2_ = adjustment;
#line 178 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp3_ = gtk_adjustment_get_upper (_tmp2_);
#line 178 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp4_ = adjustment;
#line 178 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp5_ = gtk_adjustment_get_page_size (_tmp4_);
#line 178 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	if (_tmp1_ == (_tmp3_ - _tmp5_)) {
#line 179 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		self->priv->right_aligned = TRUE;
#line 914 "math-window.c"
	} else {
#line 181 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		self->priv->right_aligned = FALSE;
#line 918 "math-window.c"
	}
}


static void _math_window_scroll_value_changed_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_window_scroll_value_changed_cb ((MathWindow*) self, _sender);
#line 926 "math-window.c"
}


static void math_window_copy_cb (MathWindow* self) {
	MathEquation* _tmp0_ = NULL;
	MathEquation* _tmp1_ = NULL;
#line 184 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 186 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = math_window_get_equation (self);
#line 186 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp1_ = _tmp0_;
#line 186 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_equation_copy (_tmp1_);
#line 941 "math-window.c"
}


static void math_window_paste_cb (MathWindow* self) {
	MathEquation* _tmp0_ = NULL;
	MathEquation* _tmp1_ = NULL;
#line 189 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 191 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = math_window_get_equation (self);
#line 191 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp1_ = _tmp0_;
#line 191 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_equation_paste (_tmp1_);
#line 956 "math-window.c"
}


static void math_window_undo_cb (MathWindow* self) {
	MathEquation* _tmp0_ = NULL;
	MathEquation* _tmp1_ = NULL;
#line 194 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 196 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = math_window_get_equation (self);
#line 196 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp1_ = _tmp0_;
#line 196 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_source_buffer_undo ((GtkSourceBuffer*) _tmp1_);
#line 971 "math-window.c"
}


static void math_window_redo_cb (MathWindow* self) {
	MathEquation* _tmp0_ = NULL;
	MathEquation* _tmp1_ = NULL;
#line 199 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 201 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = math_window_get_equation (self);
#line 201 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp1_ = _tmp0_;
#line 201 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_source_buffer_redo ((GtkSourceBuffer*) _tmp1_);
#line 986 "math-window.c"
}


static void math_window_mode_cb (MathWindow* self, GSimpleAction* action, GVariant* parameter) {
	GVariant* _tmp0_ = NULL;
	GVariant* _tmp1_ = NULL;
	const GVariantType* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GtkPopover* popover = NULL;
	GtkMenuButton* _tmp4_ = NULL;
	GtkPopover* _tmp5_ = NULL;
	GtkPopover* _tmp6_ = NULL;
	GtkPopover* _tmp7_ = NULL;
	GtkMenuButton* _tmp8_ = NULL;
	MathDisplay* _tmp9_ = NULL;
	MathDisplay* _tmp10_ = NULL;
	ButtonMode mode = 0;
	gchar* mode_str = NULL;
	GVariant* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	MathButtons* _tmp19_ = NULL;
	MathButtons* _tmp20_ = NULL;
	ButtonMode _tmp21_ = 0;
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_if_fail (action != NULL);
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = parameter;
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "parameter != null");
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp1_ = parameter;
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp2_ = G_VARIANT_TYPE_STRING;
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp3_ = g_variant_is_of_type (_tmp1_, _tmp2_);
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_vala_return_if_fail (_tmp3_, "parameter.is_of_type (VariantType.STRING)");
#line 208 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp4_ = self->priv->menu_button;
#line 208 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp5_ = gtk_menu_button_get_popover (_tmp4_);
#line 208 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 208 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	popover = _tmp6_;
#line 209 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp7_ = popover;
#line 209 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp7_);
#line 210 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp8_ = self->priv->menu_button;
#line 210 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp8_, FALSE);
#line 212 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp9_ = math_window_get_display (self);
#line 212 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp10_ = _tmp9_;
#line 212 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_display_grab_focus (_tmp10_);
#line 214 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	mode = BUTTON_MODE_BASIC;
#line 215 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp11_ = parameter;
#line 215 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp12_ = g_variant_get_string (_tmp11_, NULL);
#line 215 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 215 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	mode_str = _tmp13_;
#line 217 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp14_ = mode_str;
#line 217 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	if (g_strcmp0 (_tmp14_, "basic") == 0) {
#line 218 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		mode = BUTTON_MODE_BASIC;
#line 1066 "math-window.c"
	} else {
		const gchar* _tmp15_ = NULL;
#line 219 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		_tmp15_ = mode_str;
#line 219 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		if (g_strcmp0 (_tmp15_, "advanced") == 0) {
#line 220 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			mode = BUTTON_MODE_ADVANCED;
#line 1075 "math-window.c"
		} else {
			const gchar* _tmp16_ = NULL;
#line 221 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			_tmp16_ = mode_str;
#line 221 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
			if (g_strcmp0 (_tmp16_, "financial") == 0) {
#line 222 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				mode = BUTTON_MODE_FINANCIAL;
#line 1084 "math-window.c"
			} else {
				const gchar* _tmp17_ = NULL;
#line 223 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				_tmp17_ = mode_str;
#line 223 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
				if (g_strcmp0 (_tmp17_, "programming") == 0) {
#line 224 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
					mode = BUTTON_MODE_PROGRAMMING;
#line 1093 "math-window.c"
				} else {
					const gchar* _tmp18_ = NULL;
#line 225 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
					_tmp18_ = mode_str;
#line 225 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
					if (g_strcmp0 (_tmp18_, "keyboard") == 0) {
#line 226 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
						mode = BUTTON_MODE_KEYBOARD;
#line 1102 "math-window.c"
					} else {
#line 227 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
						g_assert_not_reached ();
#line 1106 "math-window.c"
					}
				}
			}
		}
	}
#line 229 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp19_ = math_window_get_buttons (self);
#line 229 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp20_ = _tmp19_;
#line 229 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp21_ = mode;
#line 229 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_buttons_set_mode (_tmp20_, _tmp21_);
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_free0 (mode_str);
#line 204 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (popover);
#line 1124 "math-window.c"
}


MathEquation* math_window_get_equation (MathWindow* self) {
	MathEquation* result;
	MathEquation* _tmp0_ = NULL;
#line 16 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = self->priv->_equation;
#line 16 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	result = _tmp0_;
#line 16 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	return result;
#line 1139 "math-window.c"
}


MathDisplay* math_window_get_display (MathWindow* self) {
	MathDisplay* result;
	MathDisplay* _tmp0_ = NULL;
#line 19 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = self->priv->_display;
#line 19 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	result = _tmp0_;
#line 19 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	return result;
#line 1154 "math-window.c"
}


MathButtons* math_window_get_buttons (MathWindow* self) {
	MathButtons* result;
	MathButtons* _tmp0_ = NULL;
#line 21 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_tmp0_ = self->priv->_buttons;
#line 21 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	result = _tmp0_;
#line 21 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	return result;
#line 1169 "math-window.c"
}


static void math_window_class_init (MathWindowClass * klass) {
	gint MathWindow_private_offset;
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	math_window_parent_class = g_type_class_peek_parent (klass);
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_type_class_add_private (klass, sizeof (MathWindowPrivate));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	((GtkWidgetClass *) klass)->key_press_event = math_window_real_key_press_event;
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_math_window_get_property;
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	G_OBJECT_CLASS (klass)->finalize = math_window_finalize;
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_WINDOW_EQUATION, g_param_spec_object ("equation", "equation", "equation", TYPE_MATH_EQUATION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_WINDOW_DISPLAY, g_param_spec_object ("display", "display", "display", TYPE_MATH_DISPLAY, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_WINDOW_BUTTONS, g_param_spec_object ("buttons", "buttons", "buttons", TYPE_MATH_BUTTONS, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	MathWindow_private_offset = g_type_class_get_instance_private_offset (klass);
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/calculator/math-window.ui");
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_button", FALSE, MathWindow_private_offset + G_STRUCT_OFFSET (MathWindowPrivate, menu_button));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "mode_label", FALSE, MathWindow_private_offset + G_STRUCT_OFFSET (MathWindowPrivate, mode_label));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "scrolled_window", FALSE, MathWindow_private_offset + G_STRUCT_OFFSET (MathWindowPrivate, scrolled_window));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "grid", FALSE, MathWindow_private_offset + G_STRUCT_OFFSET (MathWindowPrivate, grid));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "converter", FALSE, MathWindow_private_offset + G_STRUCT_OFFSET (MathWindowPrivate, converter));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "scroll_changed_cb", G_CALLBACK(_math_window_scroll_changed_cb_gtk_adjustment_changed));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "scroll_value_changed_cb", G_CALLBACK(_math_window_scroll_value_changed_cb_gtk_adjustment_value_changed));
#line 1209 "math-window.c"
}


static void math_window_instance_init (MathWindow * self) {
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	self->priv = MATH_WINDOW_GET_PRIVATE (self);
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	g_type_ensure (TYPE_MATH_CONVERTER);
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1220 "math-window.c"
}


static void math_window_finalize (GObject* obj) {
	MathWindow * self;
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_WINDOW, MathWindow);
#line 15 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->_equation);
#line 18 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->_display);
#line 20 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->_buttons);
#line 26 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->menu_button);
#line 28 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->mode_label);
#line 30 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->scrolled_window);
#line 32 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->grid);
#line 34 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	_g_object_unref0 (self->priv->converter);
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	G_OBJECT_CLASS (math_window_parent_class)->finalize (obj);
#line 1246 "math-window.c"
}


GType math_window_get_type (void) {
	static volatile gsize math_window_type_id__volatile = 0;
	if (g_once_init_enter (&math_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MathWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) math_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MathWindow), 0, (GInstanceInitFunc) math_window_instance_init, NULL };
		GType math_window_type_id;
		math_window_type_id = g_type_register_static (gtk_application_window_get_type (), "MathWindow", &g_define_type_info, 0);
		g_once_init_leave (&math_window_type_id__volatile, math_window_type_id);
	}
	return math_window_type_id__volatile;
}


static void _vala_math_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MathWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_WINDOW, MathWindow);
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
	switch (property_id) {
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		case MATH_WINDOW_EQUATION:
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		g_value_set_object (value, math_window_get_equation (self));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		break;
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		case MATH_WINDOW_DISPLAY:
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		g_value_set_object (value, math_window_get_display (self));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		break;
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		case MATH_WINDOW_BUTTONS:
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		g_value_set_object (value, math_window_get_buttons (self));
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		break;
#line 1285 "math-window.c"
		default:
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "/home/mcatanzaro/src/jhbuild/checkout/gnome-calculator/src/math-window.vala"
		break;
#line 1291 "math-window.c"
	}
}



